	INCLUDE EFR32MG12.inc		; CPU register definitions
	INCLUDE terminal.inc		; terminal function definitions	
	INCLUDE	i2c.inc		
	INCLUDE	si7210.inc	
	EXPORT	main
	IMPORT	GPIO_setup		; import names from other code files
	IMPORT	LETIMER_setup	
	IMPORT	I2C1_setup	
	IMPORT	mData
				
;-------------------------------------	; CODE segment in flash (ROM) 
	AREA    |.text|, CODE, READONLY
main	PROC				; main user code
	bl	Terminal_setup		; setup TeraTerm communication
	bl	GPIO_setup		; configure port pins
	bl	LETIMER_setup
	bl	I2C1_setup
	
	bl	SI7210_setup	
	bl	SI7210_request_conversion
loop					
	wfi
	bl	SI7210_get_data
	bl	SI7210_request_conversion

	ldr	R0, =mData
	ldrh	R0, [R0]		; get temp from RAM
	bl	WriteInt
	bl	NewLine
		
	b	loop			; repeat periodic task		
	ENDP

	ALIGN
	END