	INCLUDE EFR32MG12.inc			; CPU register definitions
	INCLUDE	i2c.inc	
	IMPORT	I2Cbuf	

SI7210_SLAVE_ADDRESS	EQU	0x30    	; sensor slave address

;-------------------------------------	; non-initialized DATA segment in RAM 
	AREA	RAM, DATA, NOINIT, READWRITE, ALIGN=3
mData	SPACE	2	
	EXPORT	mData				
		
	AREA    |.text|, CODE, READONLY		; another section in the CODE area
;-------------------------------------------------------------------------------
SI7210_setup	PROC
	EXPORT	SI7210_setup
	push	{LR, R0-R2}			; save used regs	
	OORW	0x14<<8, GPIO_PB_MODEH, GPIO	; enable power to ENV sensors
	OORW	1<<10, GPIO_PB_DOUT		; and configure VOUT pin for input

	ldr	R0, =10000000			; power-up delay
sd1	subs	R0, #1
	bne	sd1

	mov	R0, #SI7210_SLAVE_ADDRESS	; wake-up device from sleep
	ldr	R1, =I2Cbuf
	mov	R2, #1
	bl	I2CMasterReadBuf2

	ldr	R0, =10000000			; power-up delay
sd2	subs	R0, #1
	bne	sd2
	
	PUTB	0xC5, 0, I2Cbuf			; set arautonic bit
	PUTB	0x01, 1
	mov	R0, #SI7210_SLAVE_ADDRESS
	ldr	R1, =I2Cbuf
	mov	R2, #2
	bl	I2CMasterWriteBuf
	
	mov	R0, #SI7210_SLAVE_ADDRESS	; test output if all regs	
	ldr	R1, =I2Cbuf
	mov	R2, #17
	mov	R3, #0xC0
	bl	I2CMasterReadBuf	
	
	pop	{PC, R0-R2}
	ENDP

;-------------------------------------------------------------------------------
SI7210_request_conversion	PROC
	EXPORT	SI7210_request_conversion
	push	{LR, R0-R2}			; save used regs	
	PUTB	0xC4, 0, I2Cbuf			; set oneburst bit
	PUTB	4, 1
	mov	R0, #SI7210_SLAVE_ADDRESS
	ldr	R1, =I2Cbuf
	mov	R2, #2
	bl	I2CMasterWriteBuf
	pop	{PC, R0-R2}
	ENDP
		
;-------------------------------------------------------------------------------
SI7210_get_data	PROC
	EXPORT	SI7210_get_data
	push	{LR, R0-R2}			; save used regs
	mov	R0, #SI7210_SLAVE_ADDRESS
	ldr	R1, =I2Cbuf
	mov	R2, #2				; read 2 bytes
	mov	R3, #0xC1			; ... from this reg
	bl	I2CMasterReadBuf

	ldr	R0, =mData
	ldrh	R2, [R1]
	rev16	R2, R2
	strh	R2, [R0]			; save data in RAM	

	pop	{PC, R0-R2}
	ENDP

	ALIGN
	END	